package jcatest.inboundudp;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.resource.ResourceException;
import javax.ejb.EJBException;
import javax.ejb.MessageDrivenBean;
import javax.ejb.MessageDrivenContext;

import jcatest.outboundtcp.OutboundTCPConnection;
import jcatest.outboundtcp.OutboundTCPConnectionFactory;

public class Processor implements MessageDrivenBean, InboundUDPMessageListener {
    private boolean debug;
    private boolean test;
    private MessageDrivenContext ctx;
    @Override
    public InboundUDPMessage onMessage(InboundUDPMessage msg) {
        if(test) {
            byte[] req = msg.getData();
            byte[] resp = new byte[req.length];
            for(int i = 0; i < resp.length; i++) {
                resp[i] = (byte) (req[i] + 1);
            }
            if(debug) {
                System.out.println("Test processing");
            }
            return new InboundUDPMessage(resp);
        } else {
            try {
                Context ctx = new InitialContext();
                OutboundTCPConnectionFactory cf = (OutboundTCPConnectionFactory)ctx.lookup("java:OutboundTCP");
                OutboundTCPConnection con = (OutboundTCPConnection)cf.getConnection();
                byte[] req = msg.getData();
                byte[] resp = con.execute(req);
                con.close();
                if(debug) {
                    System.out.println("Real processing");
                }
                return new InboundUDPMessage(resp);
            } catch (NamingException e) {
                throw new EJBException(e);
            } catch (ResourceException e) {
                throw new EJBException(e);
            }
        }
    }
    @Override
    public void setDebug(boolean debug) {
        this.debug = debug;
    }
    @Override
    public void setTest(boolean test) {
        this.test = test;
    }
    public void ejbCreate() {
    }
    @Override
    public void ejbRemove() {
    }
    @Override
    public void setMessageDrivenContext(MessageDrivenContext ctx) {
        this.ctx = ctx;
    }
}

