package jcatest.inboundudp;

import javax.resource.ResourceException;
import javax.resource.spi.ActivationSpec;
import javax.resource.spi.BootstrapContext;
import javax.resource.spi.ResourceAdapter;
import javax.resource.spi.ResourceAdapterInternalException;
import javax.resource.spi.endpoint.MessageEndpointFactory;
import javax.resource.spi.work.WorkManager;
import javax.transaction.xa.XAResource;

public class InboundUDPResourceAdapter implements ResourceAdapter {
	private WorkManager wm;
	@Override
	public void endpointActivation(MessageEndpointFactory mef, ActivationSpec as) throws ResourceException {
		if(((InboundUDPActivationSpec)as).getDebug()) {
            System.out.println("adapter activation");
        }
		wm.scheduleWork(new InboundUDPWorker(mef, wm, as));
	}
	@Override
	public void endpointDeactivation(MessageEndpointFactory mef, ActivationSpec as) {
		if(((InboundUDPActivationSpec)as).getDebug()) {
            System.out.println("adapter deactivation");
        }
	}
	@Override
	public XAResource[] getXAResources(ActivationSpec[] as) throws ResourceException {
		throw new ResourceException("no XA support");
	}
	@Override
	public void start(BootstrapContext bc) throws ResourceAdapterInternalException {
		wm = bc.getWorkManager();
	}
	@Override
	public void stop() {
	}
}
