package jcatest.outboundtcp;

import javax.naming.NamingException;
import javax.naming.Reference;
import javax.resource.ResourceException;
import javax.resource.cci.Connection;
import javax.resource.cci.ConnectionSpec;
import javax.resource.cci.RecordFactory;
import javax.resource.cci.ResourceAdapterMetaData;
import javax.resource.spi.ConnectionManager;
import javax.resource.spi.ManagedConnectionFactory;

public class OutboundTCPConnectionFactoryImpl implements OutboundTCPConnectionFactory {
	private ManagedConnectionFactory mcf;
	private ConnectionManager cm;
	private Reference ref;
	private boolean debug;
	public OutboundTCPConnectionFactoryImpl(ManagedConnectionFactory mcf, ConnectionManager cm) {
		this.mcf = mcf;
		this.cm = cm;
		this.ref = null;
		this.debug = ((OutboundTCPManagedConnectionFactory)mcf).getDebug();
	}
	@Override
	public OutboundTCPConnection getConnection() throws ResourceException {
		if(debug) {
			System.out.println("OutboundTCPConnectionFactoryImpl asked for an OutboundTCPConnection without spec");
		}
		return (OutboundTCPConnection)cm.allocateConnection(mcf, null);
	}
	@Override
	public Connection getConnection(ConnectionSpec cs) throws ResourceException {
		if(debug) {
			System.out.println("OutboundTCPConnectionFactoryImpl asked for an OutboundTCPConnection with spec");
		}
		return (OutboundTCPConnection)cm.allocateConnection(mcf, null);
	}
	@Override
	public ResourceAdapterMetaData getMetaData() throws ResourceException {
		throw new ResourceException("MetaData not supported");
	}
	@Override
	public RecordFactory getRecordFactory() throws ResourceException {
		return new OutboundTCPRecordFactory();
	}
	@Override
	public Reference getReference() throws NamingException {
		return ref;
	}
	@Override
	public void setReference(Reference ref) {
		this.ref = ref;
	}
}
